loci.formats.in

## Class CellSensReader

- java.lang.Object
- - loci.formats.FormatHandler
  - - loci.formats.FormatReader
    - - loci.formats.in.CellSensReader

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable, ICompressedTileReader, IFormatHandler, IFormatReader, IMetadataConfigurable, IPyramidHandler

      public class CellSensReader
      extends FormatReader

  CellSensReader is the file format reader for cellSens .vsi files.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `(package private) class` | `CellSensReader.Pyramid`
    `(package private) class` | `CellSensReader.TileCoordinate`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private static int` | `ACCUMULATION`
    `private static int` | `ACCUMULATION_MODE`
    `private static int` | `ACQUISITION_PROPERTIES`
    `private static int` | `ACTIVE_CHANNEL`
    `private static int` | `ACTIVE_LAYER_INDEX_VECTOR`
    `private static int` | `ACTIVE_LAYER_VECTOR`
    `private static int` | `ACTIVE_STACK_DIMENSION`
    `private static int` | `ANDOR_SHIFT_SPEED`
    `private static int` | `AUTOEXPOSURE`
    `private static int` | `AVERAGING`
    `private java.util.HashMap<java.lang.Integer,byte[]>` | `backgroundColor`
    `private static int` | `BASELINE_OFFSET_CLAMP`
    `private boolean[]` | `bgr`
    `private static int` | `BGR`
    `private static int` | `BIT_DEPTH`
    `private static int` | `BLUE_GAIN`
    `private static int` | `BLUE_OFFSET`
    `private static int` | `BMP`
    `private static int` | `BOOLEAN`
    `private static int` | `BRIGHTNESS`
    `private static int` | `C`
    `private static int` | `CALIBRATION`
    `private static int` | `CAMERA_GAIN`
    `private static int` | `CAMERA_GAMMA`
    `private static int` | `CAMERA_OFFSET`
    `private static int` | `CANVAS_COLOR_1`
    `private static int` | `CANVAS_COLOR_2`
    `private static int` | `CCD_SENSITIVITY`
    `private static int` | `CHAINED_LAYERS`
    `private static int` | `CHANNEL_CONTRAST_BRIGHTNESS`
    `private static int` | `CHANNEL_DIM`
    `private static int` | `CHANNEL_GAMMA_CORRECTION`
    `private static int` | `CHANNEL_INFO_PROPERTIES`
    `private static int` | `CHANNEL_NAME`
    `private static int` | `CHANNEL_OVERFLOW`
    `private static int` | `CHANNEL_PROPERTIES`
    `private static int` | `CHANNEL_TRANSPARENCY_VALUE`
    `private static int` | `CHANNEL_VISIBLE`
    `private int` | `channelCount`
    `private static int` | `CHAR`
    `private static int` | `CLIPPING`
    `private static int` | `CLIPPING_STATE`
    `private static int` | `COARSE_FRAME_IFD`
    `private static int` | `COARSE_PYRAMID_LEVEL`
    `private static int` | `COLLECTION_VOLUME`
    `private static int` | `COLOR_SPACE`
    `private static int` | `COLORSPACE`
    `private java.util.ArrayList<java.lang.Integer>` | `cols`
    `private static int` | `COMPLEX`
    `private java.util.ArrayList<java.lang.Integer>` | `compressionType`
    `private static int` | `CONTRAST`
    `private static int` | `CONTRAST_BRIGHTNESS`
    `private static int` | `CONTRAST_TARGET`
    `private static int` | `COOLING_ON`
    `private static int` | `CREATION_TIME`
    `private static int` | `CUSTOM_GRAYSCALE`
    `private static int` | `DATE`
    `private static int` | `DEFAULT_BACKGROUND_COLOR`
    `private static int` | `DEFAULT_IMAGE`
    `private static int` | `DEFAULT_SAMPLE_IFD`
    `private static int` | `DEVICE_ID`
    `private static int` | `DEVICE_MANUFACTURER`
    `private static int` | `DEVICE_NAME`
    `private static int` | `DEVICE_SUBTYPE`
    `private static int` | `DIM_INDEX_1`
    `private static int` | `DIM_INDEX_2`
    `private static int` | `DIMENSION_DESCRIPTION_VOLUME`
    `private static int` | `DIMENSION_INCREMENT_ID`
    `private static int` | `DIMENSION_MEANING`
    `private static int` | `DIMENSION_NAME`
    `private static int` | `DIMENSION_SIZE`
    `private static int` | `DIMENSION_START_ID`
    `private static int` | `DIMENSION_VALUE_ID`
    `private int` | `dimensionTag`
    `private static int` | `DISPLAY_COLOR`
    `private static int` | `DISPLAY_CONTRAST_BRIGHTNESS`
    `private static int` | `DISPLAY_GAMMA_CORRECTION`
    `private static int` | `DISPLAY_LIMITS`
    `private static int` | `DISPLAY_LUT`
    `private static int` | `DISPLAY_MAPPING_VOLUME`
    `private static int` | `DISPLAY_PROCESSOR_TYPE`
    `private static int` | `DISPLAY_STACK_ID`
    `private static int` | `DISPLAY_STACK_INDEX`
    `private static int` | `DISPLAY_VISIBLE`
    `private static int` | `DISPLAYED_LUT_ID`
    `private static int` | `DOCUMENT_AUTHOR`
    `private static int` | `DOCUMENT_COMPANY`
    `private static int` | `DOCUMENT_CREATOR_BUILD_NUMBER`
    `private static int` | `DOCUMENT_CREATOR_MAJOR_VERSION`
    `private static int` | `DOCUMENT_CREATOR_MINOR_VERSION`
    `private static int` | `DOCUMENT_CREATOR_NAME`
    `private static int` | `DOCUMENT_CREATOR_PACKAGE`
    `private static int` | `DOCUMENT_CREATOR_SUB_VERSION`
    `private static int` | `DOCUMENT_NAME`
    `private static int` | `DOCUMENT_NOTE`
    `private static int` | `DOCUMENT_PRODUCT`
    `private static int` | `DOCUMENT_PRODUCT_NAME`
    `private static int` | `DOCUMENT_PRODUCT_VERSION`
    `private static int` | `DOCUMENT_PROPERTIES`
    `private static int` | `DOCUMENT_THUMB`
    `private static int` | `DOCUMENT_TIME`
    `private static int` | `DOCUMENT_TYPE_HINT`
    `private static int` | `DOUBLE`
    `private static int` | `DOUBLE_2`
    `private static int` | `DOUBLE_2_2`
    `private static int` | `DOUBLE_3`
    `private static int` | `DOUBLE_3_3`
    `private static int` | `DOUBLE_4`
    `private static int` | `DOUBLE_4_4`
    `private static int` | `DOUBLE_ARRAY_2`
    `private static int` | `DOUBLE_ARRAY_3`
    `private static int` | `DOUBLE_INTERVAL`
    `private static int` | `DOUBLE_RECT`
    `private static int` | `DP80_FRAME_CENTERING`
    `private static int` | `DWORD`
    `private static int` | `DYNAMIC_PROPERTIES`
    `private static int` | `EFI_HEIGHT_MAP`
    `private static int` | `EFI_SHARPNESS_MAP`
    `private static int` | `EFI_STACK`
    `private static int` | `EFI_TEXTURE_MAP`
    `private static int` | `EM_GAIN`
    `private static int` | `ENHANCED_DYNAMIC_RANGE`
    `private boolean` | `expectETS`
    `private static int` | `EXPOSURE_METERING_MODE`
    `private static int` | `EXPOSURE_TIME`
    `private static int` | `EXTERNAL_DATA_VOLUME`
    `private static int` | `EXTERNAL_FILE_PROPERTIES`
    `private static int` | `EXTRA_SAMPLES`
    `private static int` | `EXTRA_SAMPLES_PROPERTIES`
    `private java.util.ArrayList<java.lang.String>` | `extraFiles`
    `static boolean` | `FAIL_ON_MISSING_DEFAULT`
    `static java.lang.String` | `FAIL_ON_MISSING_KEY`
    `private static int` | `FAN_SPEED`
    `private static int` | `FIELD_TYPE`
    `private java.util.HashMap<java.lang.Integer,java.lang.String>` | `fileMap`
    `private static int` | `FLOAT`
    `private static int` | `FOCUS_IMAGE`
    `private boolean` | `foundChannelTag`
    `private static int` | `FRAME_ORIGIN`
    `private static int` | `FRAME_PROPERTIES`
    `private static int` | `FRAME_SCALE`
    `private static int` | `FRAME_SIZE`
    `private static int` | `FRAME_TRANSFER`
    `private static int` | `FRAME_TYPE`
    `private static int` | `GAIN_UNIT`
    `private static int` | `GAMMA_CORRECTION`
    `private static int` | `GRADIENT_LUT`
    `private static int` | `GREEN_GAIN`
    `private static int` | `GREEN_OFFSET`
    `private static int` | `HAS_EXTERNAL_FILE`
    `private static int` | `HDRI_EXPOSURE_RANGE`
    `private static int` | `HDRI_FRAMES`
    `private static int` | `HDRI_MAP_MODE`
    `private static int` | `HDRI_ON`
    `private static int` | `HIDDEN_LAYER`
    `private static int` | `HOT_PIXEL_CORRECTION`
    `private static int` | `ICC_ENABLED`
    `private IFDList` | `ifds`
    `private static int` | `IMAGE_BOUNDARY`
    `private static int` | `IMAGE_COLLECTION_PROPERTIES`
    `private static int` | `IMAGE_FRAME_VOLUME`
    `private boolean` | `inDimensionProperties`
    `private static int` | `INT`
    `private static int` | `INT_2`
    `private static int` | `INT_3`
    `private static int` | `INT_4`
    `private static int` | `INT_ARRAY_2`
    `private static int` | `INT_ARRAY_3`
    `private static int` | `INT_ARRAY_4`
    `private static int` | `INT_ARRAY_5`
    `private static int` | `INT_INTERVAL`
    `private static int` | `INT_RECT`
    `private static int` | `IS_TRANSMISSION`
    `private static int` | `ISO_SENSITIVITY`
    `private boolean` | `jpeg`
    `private static int` | `JPEG`
    `private static int` | `JPEG_2000`
    `private static int` | `JPEG_LOSSLESS`
    `private static int` | `LAMBDA`
    `private static int` | `LAMBDA_INCREMENT`
    `private static int` | `LAMBDA_START`
    `private static int` | `LAMBDA_VALUE`
    `private static int` | `LAYER_INFO_PROPERTIES`
    `private static int` | `LAYER_SELECTION`
    `private static int` | `LAYER_SELECTION_INDEX`
    `private static int` | `LAYER_XY_FIXED`
    `private static int` | `LIVE_OVERFLOW`
    `private static int` | `LONG`
    `private static int` | `MACRO_IMAGE`
    `private static int` | `MAGNIFICATION`
    `private static int` | `MEM_MODEL`
    `private int` | `metadataIndex`
    `private static int` | `MIRROR_H`
    `private static int` | `MIRROR_V`
    `private static int` | `MULTIDIM_IMAGE_VOLUME`
    `private static int` | `MULTIDIM_STACK_PROPERTIES`
    `private java.util.ArrayList<java.lang.Integer>` | `nDimensions`
    `private static int` | `NEW_MDIM_VOLUME_HEADER`
    `private static int` | `NEW_VOLUME_HEADER`
    `private static int` | `NOISE_REDUCTION`
    `private static int` | `NUMERICAL_APERTURE`
    `private static int` | `OBJECTIVE_MAG`
    `private static int` | `OBJECTIVE_NAME`
    `private static int` | `OBJECTIVE_TYPE`
    `private static int` | `OPTICAL_PATH`
    `private static int` | `ORIGINAL_FRAME_RATE`
    `private static int` | `OVERVIEW_IMAGE`
    `private TiffParser` | `parser`
    `private static int` | `PHASE`
    `private static int` | `PHOTOBLEACHING`
    `private static int` | `PHOTON_IMAGING_MODE`
    `private static int` | `PIXEL_CLOCK`
    `private static int` | `PIXEL_INFO_TYPE`
    `private static int` | `PLANE_ORIGIN_RWC`
    `private static int` | `PLANE_SCALE_RWC`
    `private static int` | `PLANE_UNIT`
    `private static int` | `PNG`
    `private static int` | `PREAMP_GAIN_VALUE`
    `private int` | `previousTag`
    `private static int` | `PROPERTY_SET_VOLUME`
    `private java.util.ArrayList<CellSensReader.Pyramid>` | `pyramids`
    `private static int` | `RAW`
    `private static int` | `RED_GAIN`
    `private static int` | `RED_OFFSET`
    `private static int` | `REFRACTIVE_INDEX`
    `private static int` | `RENDER_OPERATION_ID`
    `private static int` | `RGB`
    `private java.util.ArrayList<java.lang.Integer>` | `rows`
    `private static int` | `RWC_FRAME_ORIGIN`
    `private static int` | `RWC_FRAME_SCALE`
    `private static int` | `RWC_FRAME_UNIT`
    `private static int` | `SAMPLE_FLAGS_LIST`
    `private static int` | `SAMPLE_ID_LIST`
    `private static int` | `SAMPLE_MASK`
    `private static int` | `SATURATION`
    `private static int` | `SELECTED_CHANNELS`
    `private static int` | `SELECTED_FRAMES`
    `private static int` | `SERIALIZED_MASK`
    `private static int` | `SHADING_MUL`
    `private static int` | `SHADING_SUB`
    `private static int` | `SHARPNESS`
    `private static int` | `SHORT`
    `private static int` | `SIGNAL_OUTPUT`
    `private static int` | `SLIDE_INFO`
    `private static int` | `SLIDE_NAME`
    `private static int` | `SLIDE_PREPARATION`
    `private static int` | `SLIDE_PROPERTIES`
    `private static int` | `SLIDE_SPECIMEN`
    `private static int` | `SLIDE_STAINING`
    `private static int` | `SLIDE_TISSUE`
    `private static int` | `SPURIOUS_NOISE_REMOVAL`
    `private static int` | `STACK_DISPLAY_LUT`
    `private static int` | `STACK_NAME`
    `private static int` | `STACK_TYPE`
    `private static int` | `T`
    `private static int` | `TCHAR`
    `private static int` | `TEMPERATURE_TARGET`
    `private static int` | `THIRD_ID`
    `private static int` | `TIFF_IFD`
    `private static int` | `TILE_ORIGIN`
    `private static int` | `TILE_SYSTEM`
    `private java.util.ArrayList<java.util.ArrayList<CellSensReader.TileCoordinate>>` | `tileMap`
    `private java.util.ArrayList<java.lang.Long[]>` | `tileOffsets`
    `private java.util.ArrayList<java.lang.Integer>` | `tileX`
    `private java.util.ArrayList<java.lang.Integer>` | `tileY`
    `private static int` | `TIME_INCREMENT`
    `private static int` | `TIME_START`
    `private static int` | `TIME_VALUE`
    `private static int` | `TIMESTAMP`
    `private static int` | `TRANSPARENCY_ID`
    `private static int` | `TRANSPARENCY_VALUE`
    `private static int` | `UCHAR`
    `private static int` | `UINT`
    `private static int` | `ULONG`
    `private static int` | `UNICODE_TCHAR`
    `private static int` | `UNKNOWN`
    `private static int` | `UNKNOWN_BLOBS_VOLUME`
    `private static int` | `USE_ORIGINAL_FRAME_RATE`
    `private java.lang.String[]` | `usedFiles`
    `private static int` | `USHORT`
    `private static int` | `VALUE`
    `private static int` | `VCLOCK_AMPLITUDE`
    `private static int` | `VECTOR_DATA`
    `private static int` | `VECTOR_LAYER_VOLUME`
    `private static int` | `VERSION_NUMBER`
    `private static int` | `VOLUME_INDEX`
    `private static int` | `WB_MODE`
    `private static int` | `WB_PRESET_ID`
    `private static int` | `WB_PRESET_NAME`
    `private static int` | `WIDER`
    `private static int` | `WIDER_ENABLED`
    `private static int` | `WORKING_DISTANCE`
    `private static int` | `X_BINNING`
    `private static int` | `Y_BINNING`
    `private static int` | `Y_DIMENSION_UNIT`
    `private static int` | `Y_PLANE_DIMENSION_UNIT`
    `private static int` | `Z`
    `private static int` | `Z_INCREMENT`
    `private static int` | `Z_START`
    `private static int` | `Z_VALUE`
    `private int` | `zCount`

    - ### Fields inherited from class loci.formats.FormatReader

      `core, coreIndex, datasetDescription, domains, fillColor, filterMetadata, flattenedResolutions, group, hasCompanionFiles, in, indexedAsRGB, metadata, metadataStore, normalizeData, resolution, saveOriginalMetadata, series, suffixNecessary, suffixSufficient, THUMBNAIL_DIMENSION`

    - ### Fields inherited from class loci.formats.FormatHandler

      `COMPRESSION_SUFFIXES, currentId, format, LOGGER, metadataOptions, suffixes`

    - ### Fields inherited from interface loci.formats.IFormatReader

      `CAN_GROUP, CANNOT_GROUP, MUST_GROUP`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CellSensReader()` Constructs a new cellSens reader.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close(boolean fileOnly)` Closes the currently open file.
    `private int` | `convertPixelType(int pixelType)`
    `private byte[]` | `decodeTile(int no, int row, int col)`
    `boolean` | `failOnMissingETS()`
    `int` | `fileGroupOption(java.lang.String id)` Returns an indication of whether the files in a multi-file dataset can be handled individually.
    `protected java.util.ArrayList<java.lang.String>` | `getAvailableOptions()` Returns the list of available metadata options.
    `private CellSensReader.Pyramid` | `getCurrentPyramid()` Get an object representing the pyramid which contains the current series/resolution.
    `private int` | `getCurrentPyramidIndex()` Get an index to the pyramid which contains the current series/resolution.
    `private java.lang.String` | `getDeviceSubtype(java.lang.String type)`
    `private int` | `getIFDIndex()`
    `int` | `getOptimalTileHeight()` Returns the optimal sub-image height for use with openBytes.
    `int` | `getOptimalTileWidth()` Returns the optimal sub-image width for use with openBytes.
    `private int` | `getResolutionIndex()` Get the current pyramid resolution, accounting for flattened resolutions as needed.
    `java.lang.String[]` | `getSeriesUsedFiles(boolean noPixels)` Returns an array of filenames needed to open the current series.
    `private java.lang.String` | `getStackType(java.lang.String type)`
    `private java.lang.String` | `getTagName(int tag)`
    `private int` | `getTileSize()` Get the expected decompressed size of a single tile, in bytes.
    `private java.lang.String` | `getVolumeName(int tag)`
    `protected void` | `initFile(java.lang.String id)` Initializes the given file (parsing header information, etc.).
    `boolean` | `isSingleFile(java.lang.String id)` Returns true if the named file is expected to be the only file in the dataset.
    `byte[]` | `openBytes(int no, byte[] buf, int x, int y, int w, int h)` Obtains a sub-image of the specified image plane into a pre-allocated byte array.
    `byte[]` | `openThumbBytes(int no)` Obtains a thumbnail for the specified image plane from the current file, as a byte array.
    `private boolean` | `parseETSFile(loci.common.RandomAccessInputStream etsFile, java.lang.String file, int s, boolean hasOrphanEtsFiles)`
    `private void` | `readTags(loci.common.RandomAccessInputStream vsi, boolean populateMetadata, java.lang.String tagPrefix)`
    `void` | `reopenFile()` Reopen any files that were closed, and which are expected to be open while the reader is open.

    - ### Methods inherited from class loci.formats.FormatReader

      `addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMetaList, addMeta, addMetaList, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMetaList, close, coreIndexToSeries, flattenHashtables, get16BitLookupTable, get8BitLookupTable, getAcquisitionMode, getAdvancedSeriesUsedFiles, getAdvancedUsedFiles, getArcType, getBinning, getBitsPerPixel, getCompression, getContrastMethod, getCoreIndex, getCoreMetadataList, getCorrection, getCurrentCore, getCurrentFile, getDatasetStructureDescription, getDetectorType, getDimensionOrder, getDimensionOrder, getDomains, getEffectiveSizeC, getExperimentType, getFilamentType, getFillColor, getFillRule, getFilterType, getFontFamily, getFontStyle, getGlobalMeta, getGlobalMetadata, getIlluminationType, getImageCount, getImmersion, getIndex, getIndex, getLaserMedium, getLaserType, getMarker, getMedium, getMetadataStore, getMetadataStoreRoot, getMetadataValue, getMicrobeamManipulationType, getMicroscopeType, getModuloC, getModuloT, getModuloZ, getNamingConvention, getPixelType, getPixelType, getPossibleDomains, getPulse, getRequiredDirectories, getResolution, getResolutionCount, getRGBChannelCount, getRotationTransform, getSeries, getSeriesCount, getSeriesMeta, getSeriesMetadata, getSeriesMetadataValue, getSeriesUsedFiles, getSizeC, getSizeT, getSizeX, getSizeY, getSizeZ, getThumbSizeX, getThumbSizeY, getTileColumns, getTileRows, getUnderlyingReaders, getUsedFiles, getUsedFiles, getZCTCoords, getZCTModuloCoords, hasCompanionFiles, hasFlattenedResolutions, isFalseColor, isGroupFiles, isIndexed, isInterleaved, isInterleaved, isLittleEndian, isMetadataComplete, isMetadataFiltered, isNormalized, isOrderCertain, isOriginalMetadataPopulated, isRGB, isThisType, isThisType, isThisType, isThisType, isThumbnailSeries, isUsedFile, makeFilterMetadata, openBytes, openBytes, openBytes, openPlane, readPlane, readPlane, readPlane, seriesToCoreIndex, setCoreIndex, setFillColor, setFlattenedResolutions, setGroupFiles, setId, setMetadataFiltered, setMetadataStore, setNormalized, setOriginalMetadataPopulated, setResolution, setSeries, updateMetadataLists`

    - ### Methods inherited from class loci.formats.FormatHandler

      `checkSuffix, checkSuffix, getFormat, getMetadataOptions, getNativeDataType, getSuffixes, getSupportedMetadataLevels, setMetadataOptions`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface loci.formats.IFormatHandler

      `getFormat, getNativeDataType, getSuffixes`

    - ### Methods inherited from interface loci.formats.IMetadataConfigurable

      `getMetadataOptions, getSupportedMetadataLevels, setMetadataOptions`

    - ### Methods inherited from interface loci.formats.ICompressedTileReader

      `getTileCodec, getTileCodecOptions, openCompressedBytes, openCompressedBytes`

- - ### Field Detail

    - #### FAIL_ON_MISSING_KEY

          public static final java.lang.String FAIL_ON_MISSING_KEY

      See Also:
        Constant Field Values

    - #### FAIL_ON_MISSING_DEFAULT

          public static final boolean FAIL_ON_MISSING_DEFAULT

      See Also:
        Constant Field Values

    - #### RAW

          private static final int RAW

      See Also:
        Constant Field Values

    - #### JPEG

          private static final int JPEG

      See Also:
        Constant Field Values

    - #### JPEG_2000

          private static final int JPEG_2000

      See Also:
        Constant Field Values

    - #### JPEG_LOSSLESS

          private static final int JPEG_LOSSLESS

      See Also:
        Constant Field Values

    - #### PNG

          private static final int PNG

      See Also:
        Constant Field Values

    - #### BMP

          private static final int BMP

      See Also:
        Constant Field Values

    - #### CHAR

          private static final int CHAR

      See Also:
        Constant Field Values

    - #### UCHAR

          private static final int UCHAR

      See Also:
        Constant Field Values

    - #### SHORT

          private static final int SHORT

      See Also:
        Constant Field Values

    - #### USHORT

          private static final int USHORT

      See Also:
        Constant Field Values

    - #### INT

          private static final int INT

      See Also:
        Constant Field Values

    - #### UINT

          private static final int UINT

      See Also:
        Constant Field Values

    - #### LONG

          private static final int LONG

      See Also:
        Constant Field Values

    - #### ULONG

          private static final int ULONG

      See Also:
        Constant Field Values

    - #### FLOAT

          private static final int FLOAT

      See Also:
        Constant Field Values

    - #### DOUBLE

          private static final int DOUBLE

      See Also:
        Constant Field Values

    - #### COMPLEX

          private static final int COMPLEX

      See Also:
        Constant Field Values

    - #### BOOLEAN

          private static final int BOOLEAN

      See Also:
        Constant Field Values

    - #### TCHAR

          private static final int TCHAR

      See Also:
        Constant Field Values

    - #### DWORD

          private static final int DWORD

      See Also:
        Constant Field Values

    - #### TIMESTAMP

          private static final int TIMESTAMP

      See Also:
        Constant Field Values

    - #### DATE

          private static final int DATE

      See Also:
        Constant Field Values

    - #### INT_2

          private static final int INT_2

      See Also:
        Constant Field Values

    - #### INT_3

          private static final int INT_3

      See Also:
        Constant Field Values

    - #### INT_4

          private static final int INT_4

      See Also:
        Constant Field Values

    - #### INT_RECT

          private static final int INT_RECT

      See Also:
        Constant Field Values

    - #### DOUBLE_2

          private static final int DOUBLE_2

      See Also:
        Constant Field Values

    - #### DOUBLE_3

          private static final int DOUBLE_3

      See Also:
        Constant Field Values

    - #### DOUBLE_4

          private static final int DOUBLE_4

      See Also:
        Constant Field Values

    - #### DOUBLE_RECT

          private static final int DOUBLE_RECT

      See Also:
        Constant Field Values

    - #### DOUBLE_2_2

          private static final int DOUBLE_2_2

      See Also:
        Constant Field Values

    - #### DOUBLE_3_3

          private static final int DOUBLE_3_3

      See Also:
        Constant Field Values

    - #### DOUBLE_4_4

          private static final int DOUBLE_4_4

      See Also:
        Constant Field Values

    - #### INT_INTERVAL

          private static final int INT_INTERVAL

      See Also:
        Constant Field Values

    - #### DOUBLE_INTERVAL

          private static final int DOUBLE_INTERVAL

      See Also:
        Constant Field Values

    - #### RGB

          private static final int RGB

      See Also:
        Constant Field Values

    - #### BGR

          private static final int BGR

      See Also:
        Constant Field Values

    - #### FIELD_TYPE

          private static final int FIELD_TYPE

      See Also:
        Constant Field Values

    - #### MEM_MODEL

          private static final int MEM_MODEL

      See Also:
        Constant Field Values

    - #### COLOR_SPACE

          private static final int COLOR_SPACE

      See Also:
        Constant Field Values

    - #### INT_ARRAY_2

          private static final int INT_ARRAY_2

      See Also:
        Constant Field Values

    - #### INT_ARRAY_3

          private static final int INT_ARRAY_3

      See Also:
        Constant Field Values

    - #### INT_ARRAY_4

          private static final int INT_ARRAY_4

      See Also:
        Constant Field Values

    - #### INT_ARRAY_5

          private static final int INT_ARRAY_5

      See Also:
        Constant Field Values

    - #### DOUBLE_ARRAY_2

          private static final int DOUBLE_ARRAY_2

      See Also:
        Constant Field Values

    - #### DOUBLE_ARRAY_3

          private static final int DOUBLE_ARRAY_3

      See Also:
        Constant Field Values

    - #### UNICODE_TCHAR

          private static final int UNICODE_TCHAR

      See Also:
        Constant Field Values

    - #### DIM_INDEX_1

          private static final int DIM_INDEX_1

      See Also:
        Constant Field Values

    - #### DIM_INDEX_2

          private static final int DIM_INDEX_2

      See Also:
        Constant Field Values

    - #### VOLUME_INDEX

          private static final int VOLUME_INDEX

      See Also:
        Constant Field Values

    - #### PIXEL_INFO_TYPE

          private static final int PIXEL_INFO_TYPE

      See Also:
        Constant Field Values

    - #### NEW_VOLUME_HEADER

          private static final int NEW_VOLUME_HEADER

      See Also:
        Constant Field Values

    - #### PROPERTY_SET_VOLUME

          private static final int PROPERTY_SET_VOLUME

      See Also:
        Constant Field Values

    - #### NEW_MDIM_VOLUME_HEADER

          private static final int NEW_MDIM_VOLUME_HEADER

      See Also:
        Constant Field Values

    - #### TIFF_IFD

          private static final int TIFF_IFD

      See Also:
        Constant Field Values

    - #### VECTOR_DATA

          private static final int VECTOR_DATA

      See Also:
        Constant Field Values

    - #### COLLECTION_VOLUME

          private static final int COLLECTION_VOLUME

      See Also:
        Constant Field Values

    - #### MULTIDIM_IMAGE_VOLUME

          private static final int MULTIDIM_IMAGE_VOLUME

      See Also:
        Constant Field Values

    - #### IMAGE_FRAME_VOLUME

          private static final int IMAGE_FRAME_VOLUME

      See Also:
        Constant Field Values

    - #### DIMENSION_SIZE

          private static final int DIMENSION_SIZE

      See Also:
        Constant Field Values

    - #### IMAGE_COLLECTION_PROPERTIES

          private static final int IMAGE_COLLECTION_PROPERTIES

      See Also:
        Constant Field Values

    - #### MULTIDIM_STACK_PROPERTIES

          private static final int MULTIDIM_STACK_PROPERTIES

      See Also:
        Constant Field Values

    - #### FRAME_PROPERTIES

          private static final int FRAME_PROPERTIES

      See Also:
        Constant Field Values

    - #### DIMENSION_DESCRIPTION_VOLUME

          private static final int DIMENSION_DESCRIPTION_VOLUME

      See Also:
        Constant Field Values

    - #### CHANNEL_PROPERTIES

          private static final int CHANNEL_PROPERTIES

      See Also:
        Constant Field Values

    - #### DISPLAY_MAPPING_VOLUME

          private static final int DISPLAY_MAPPING_VOLUME

      See Also:
        Constant Field Values

    - #### LAYER_INFO_PROPERTIES

          private static final int LAYER_INFO_PROPERTIES

      See Also:
        Constant Field Values

    - #### CHANNEL_INFO_PROPERTIES

          private static final int CHANNEL_INFO_PROPERTIES

      See Also:
        Constant Field Values

    - #### DEFAULT_SAMPLE_IFD

          private static final int DEFAULT_SAMPLE_IFD

      See Also:
        Constant Field Values

    - #### VECTOR_LAYER_VOLUME

          private static final int VECTOR_LAYER_VOLUME

      See Also:
        Constant Field Values

    - #### EXTERNAL_FILE_PROPERTIES

          private static final int EXTERNAL_FILE_PROPERTIES

      See Also:
        Constant Field Values

    - #### COARSE_FRAME_IFD

          private static final int COARSE_FRAME_IFD

      See Also:
        Constant Field Values

    - #### COARSE_PYRAMID_LEVEL

          private static final int COARSE_PYRAMID_LEVEL

      See Also:
        Constant Field Values

    - #### SERIALIZED_MASK

          private static final int SERIALIZED_MASK

      See Also:
        Constant Field Values

    - #### UNKNOWN_BLOBS_VOLUME

          private static final int UNKNOWN_BLOBS_VOLUME

      See Also:
        Constant Field Values

    - #### SAMPLE_ID_LIST

          private static final int SAMPLE_ID_LIST

      See Also:
        Constant Field Values

    - #### EXTRA_SAMPLES

          private static final int EXTRA_SAMPLES

      See Also:
        Constant Field Values

    - #### EXTRA_SAMPLES_PROPERTIES

          private static final int EXTRA_SAMPLES_PROPERTIES

      See Also:
        Constant Field Values

    - #### SAMPLE_FLAGS_LIST

          private static final int SAMPLE_FLAGS_LIST

      See Also:
        Constant Field Values

    - #### FRAME_TYPE

          private static final int FRAME_TYPE

      See Also:
        Constant Field Values

    - #### DEFAULT_BACKGROUND_COLOR

          private static final int DEFAULT_BACKGROUND_COLOR

      See Also:
        Constant Field Values

    - #### VERSION_NUMBER

          private static final int VERSION_NUMBER

      See Also:
        Constant Field Values

    - #### DOCUMENT_PROPERTIES

          private static final int DOCUMENT_PROPERTIES

      See Also:
        Constant Field Values

    - #### DOCUMENT_NAME

          private static final int DOCUMENT_NAME

      See Also:
        Constant Field Values

    - #### DOCUMENT_NOTE

          private static final int DOCUMENT_NOTE

      See Also:
        Constant Field Values

    - #### DOCUMENT_TIME

          private static final int DOCUMENT_TIME

      See Also:
        Constant Field Values

    - #### DOCUMENT_AUTHOR

          private static final int DOCUMENT_AUTHOR

      See Also:
        Constant Field Values

    - #### DOCUMENT_COMPANY

          private static final int DOCUMENT_COMPANY

      See Also:
        Constant Field Values

    - #### DOCUMENT_CREATOR_NAME

          private static final int DOCUMENT_CREATOR_NAME

      See Also:
        Constant Field Values

    - #### DOCUMENT_CREATOR_MAJOR_VERSION

          private static final int DOCUMENT_CREATOR_MAJOR_VERSION

      See Also:
        Constant Field Values

    - #### DOCUMENT_CREATOR_MINOR_VERSION

          private static final int DOCUMENT_CREATOR_MINOR_VERSION

      See Also:
        Constant Field Values

    - #### DOCUMENT_CREATOR_SUB_VERSION

          private static final int DOCUMENT_CREATOR_SUB_VERSION

      See Also:
        Constant Field Values

    - #### DOCUMENT_CREATOR_BUILD_NUMBER

          private static final int DOCUMENT_CREATOR_BUILD_NUMBER

      See Also:
        Constant Field Values

    - #### DOCUMENT_CREATOR_PACKAGE

          private static final int DOCUMENT_CREATOR_PACKAGE

      See Also:
        Constant Field Values

    - #### DOCUMENT_PRODUCT

          private static final int DOCUMENT_PRODUCT

      See Also:
        Constant Field Values

    - #### DOCUMENT_PRODUCT_NAME

          private static final int DOCUMENT_PRODUCT_NAME

      See Also:
        Constant Field Values

    - #### DOCUMENT_PRODUCT_VERSION

          private static final int DOCUMENT_PRODUCT_VERSION

      See Also:
        Constant Field Values

    - #### DOCUMENT_TYPE_HINT

          private static final int DOCUMENT_TYPE_HINT

      See Also:
        Constant Field Values

    - #### DOCUMENT_THUMB

          private static final int DOCUMENT_THUMB

      See Also:
        Constant Field Values

    - #### SLIDE_PROPERTIES

          private static final int SLIDE_PROPERTIES

      See Also:
        Constant Field Values

    - #### SLIDE_SPECIMEN

          private static final int SLIDE_SPECIMEN

      See Also:
        Constant Field Values

    - #### SLIDE_TISSUE

          private static final int SLIDE_TISSUE

      See Also:
        Constant Field Values

    - #### SLIDE_PREPARATION

          private static final int SLIDE_PREPARATION

      See Also:
        Constant Field Values

    - #### SLIDE_STAINING

          private static final int SLIDE_STAINING

      See Also:
        Constant Field Values

    - #### SLIDE_INFO

          private static final int SLIDE_INFO

      See Also:
        Constant Field Values

    - #### SLIDE_NAME

          private static final int SLIDE_NAME

      See Also:
        Constant Field Values

    - #### DYNAMIC_PROPERTIES

          private static final int DYNAMIC_PROPERTIES

      See Also:
        Constant Field Values

    - #### MAGNIFICATION

          private static final int MAGNIFICATION

      See Also:
        Constant Field Values

    - #### IMAGE_BOUNDARY

          private static final int IMAGE_BOUNDARY

      See Also:
        Constant Field Values

    - #### TILE_SYSTEM

          private static final int TILE_SYSTEM

      See Also:
        Constant Field Values

    - #### HAS_EXTERNAL_FILE

          private static final int HAS_EXTERNAL_FILE

      See Also:
        Constant Field Values

    - #### EXTERNAL_DATA_VOLUME

          private static final int EXTERNAL_DATA_VOLUME

      See Also:
        Constant Field Values

    - #### TILE_ORIGIN

          private static final int TILE_ORIGIN

      See Also:
        Constant Field Values

    - #### EXPOSURE_TIME

          private static final int EXPOSURE_TIME

      See Also:
        Constant Field Values

    - #### CAMERA_GAIN

          private static final int CAMERA_GAIN

      See Also:
        Constant Field Values

    - #### CAMERA_OFFSET

          private static final int CAMERA_OFFSET

      See Also:
        Constant Field Values

    - #### CAMERA_GAMMA

          private static final int CAMERA_GAMMA

      See Also:
        Constant Field Values

    - #### SHARPNESS

          private static final int SHARPNESS

      See Also:
        Constant Field Values

    - #### RED_GAIN

          private static final int RED_GAIN

      See Also:
        Constant Field Values

    - #### GREEN_GAIN

          private static final int GREEN_GAIN

      See Also:
        Constant Field Values

    - #### BLUE_GAIN

          private static final int BLUE_GAIN

      See Also:
        Constant Field Values

    - #### RED_OFFSET

          private static final int RED_OFFSET

      See Also:
        Constant Field Values

    - #### GREEN_OFFSET

          private static final int GREEN_OFFSET

      See Also:
        Constant Field Values

    - #### BLUE_OFFSET

          private static final int BLUE_OFFSET

      See Also:
        Constant Field Values

    - #### SHADING_SUB

          private static final int SHADING_SUB

      See Also:
        Constant Field Values

    - #### SHADING_MUL

          private static final int SHADING_MUL

      See Also:
        Constant Field Values

    - #### X_BINNING

          private static final int X_BINNING

      See Also:
        Constant Field Values

    - #### Y_BINNING

          private static final int Y_BINNING

      See Also:
        Constant Field Values

    - #### CLIPPING

          private static final int CLIPPING

      See Also:
        Constant Field Values

    - #### MIRROR_H

          private static final int MIRROR_H

      See Also:
        Constant Field Values

    - #### MIRROR_V

          private static final int MIRROR_V

      See Also:
        Constant Field Values

    - #### CLIPPING_STATE

          private static final int CLIPPING_STATE

      See Also:
        Constant Field Values

    - #### ICC_ENABLED

          private static final int ICC_ENABLED

      See Also:
        Constant Field Values

    - #### BRIGHTNESS

          private static final int BRIGHTNESS

      See Also:
        Constant Field Values

    - #### CONTRAST

          private static final int CONTRAST

      See Also:
        Constant Field Values

    - #### CONTRAST_TARGET

          private static final int CONTRAST_TARGET

      See Also:
        Constant Field Values

    - #### ACCUMULATION

          private static final int ACCUMULATION

      See Also:
        Constant Field Values

    - #### AVERAGING

          private static final int AVERAGING

      See Also:
        Constant Field Values

    - #### ISO_SENSITIVITY

          private static final int ISO_SENSITIVITY

      See Also:
        Constant Field Values

    - #### ACCUMULATION_MODE

          private static final int ACCUMULATION_MODE

      See Also:
        Constant Field Values

    - #### AUTOEXPOSURE

          private static final int AUTOEXPOSURE

      See Also:
        Constant Field Values

    - #### EXPOSURE_METERING_MODE

          private static final int EXPOSURE_METERING_MODE

      See Also:
        Constant Field Values

    - #### FRAME_SIZE

          private static final int FRAME_SIZE

      See Also:
        Constant Field Values

    - #### BIT_DEPTH

          private static final int BIT_DEPTH

      See Also:
        Constant Field Values

    - #### HDRI_ON

          private static final int HDRI_ON

      See Also:
        Constant Field Values

    - #### HDRI_FRAMES

          private static final int HDRI_FRAMES

      See Also:
        Constant Field Values

    - #### HDRI_EXPOSURE_RANGE

          private static final int HDRI_EXPOSURE_RANGE

      See Also:
        Constant Field Values

    - #### HDRI_MAP_MODE

          private static final int HDRI_MAP_MODE

      See Also:
        Constant Field Values

    - #### CUSTOM_GRAYSCALE

          private static final int CUSTOM_GRAYSCALE

      See Also:
        Constant Field Values

    - #### SATURATION

          private static final int SATURATION

      See Also:
        Constant Field Values

    - #### WB_PRESET_ID

          private static final int WB_PRESET_ID

      See Also:
        Constant Field Values

    - #### WB_PRESET_NAME

          private static final int WB_PRESET_NAME

      See Also:
        Constant Field Values

    - #### WB_MODE

          private static final int WB_MODE

      See Also:
        Constant Field Values

    - #### CCD_SENSITIVITY

          private static final int CCD_SENSITIVITY

      See Also:
        Constant Field Values

    - #### ENHANCED_DYNAMIC_RANGE

          private static final int ENHANCED_DYNAMIC_RANGE

      See Also:
        Constant Field Values

    - #### PIXEL_CLOCK

          private static final int PIXEL_CLOCK

      See Also:
        Constant Field Values

    - #### COLORSPACE

          private static final int COLORSPACE

      See Also:
        Constant Field Values

    - #### COOLING_ON

          private static final int COOLING_ON

      See Also:
        Constant Field Values

    - #### FAN_SPEED

          private static final int FAN_SPEED

      See Also:
        Constant Field Values

    - #### TEMPERATURE_TARGET

          private static final int TEMPERATURE_TARGET

      See Also:
        Constant Field Values

    - #### GAIN_UNIT

          private static final int GAIN_UNIT

      See Also:
        Constant Field Values

    - #### EM_GAIN

          private static final int EM_GAIN

      See Also:
        Constant Field Values

    - #### PHOTON_IMAGING_MODE

          private static final int PHOTON_IMAGING_MODE

      See Also:
        Constant Field Values

    - #### FRAME_TRANSFER

          private static final int FRAME_TRANSFER

      See Also:
        Constant Field Values

    - #### ANDOR_SHIFT_SPEED

          private static final int ANDOR_SHIFT_SPEED

      See Also:
        Constant Field Values

    - #### VCLOCK_AMPLITUDE

          private static final int VCLOCK_AMPLITUDE

      See Also:
        Constant Field Values

    - #### SPURIOUS_NOISE_REMOVAL

          private static final int SPURIOUS_NOISE_REMOVAL

      See Also:
        Constant Field Values

    - #### SIGNAL_OUTPUT

          private static final int SIGNAL_OUTPUT

      See Also:
        Constant Field Values

    - #### BASELINE_OFFSET_CLAMP

          private static final int BASELINE_OFFSET_CLAMP

      See Also:
        Constant Field Values

    - #### DP80_FRAME_CENTERING

          private static final int DP80_FRAME_CENTERING

      See Also:
        Constant Field Values

    - #### HOT_PIXEL_CORRECTION

          private static final int HOT_PIXEL_CORRECTION

      See Also:
        Constant Field Values

    - #### NOISE_REDUCTION

          private static final int NOISE_REDUCTION

      See Also:
        Constant Field Values

    - #### WIDER

          private static final int WIDER

      See Also:
        Constant Field Values

    - #### PHOTOBLEACHING

          private static final int PHOTOBLEACHING

      See Also:
        Constant Field Values

    - #### PREAMP_GAIN_VALUE

          private static final int PREAMP_GAIN_VALUE

      See Also:
        Constant Field Values

    - #### WIDER_ENABLED

          private static final int WIDER_ENABLED

      See Also:
        Constant Field Values

    - #### Z_START

          private static final int Z_START

      See Also:
        Constant Field Values

    - #### Z_INCREMENT

          private static final int Z_INCREMENT

      See Also:
        Constant Field Values

    - #### Z_VALUE

          private static final int Z_VALUE

      See Also:
        Constant Field Values

    - #### TIME_START

          private static final int TIME_START

      See Also:
        Constant Field Values

    - #### TIME_INCREMENT

          private static final int TIME_INCREMENT

      See Also:
        Constant Field Values

    - #### TIME_VALUE

          private static final int TIME_VALUE

      See Also:
        Constant Field Values

    - #### LAMBDA_START

          private static final int LAMBDA_START

      See Also:
        Constant Field Values

    - #### LAMBDA_INCREMENT

          private static final int LAMBDA_INCREMENT

      See Also:
        Constant Field Values

    - #### LAMBDA_VALUE

          private static final int LAMBDA_VALUE

      See Also:
        Constant Field Values

    - #### DIMENSION_NAME

          private static final int DIMENSION_NAME

      See Also:
        Constant Field Values

    - #### DIMENSION_MEANING

          private static final int DIMENSION_MEANING

      See Also:
        Constant Field Values

    - #### DIMENSION_START_ID

          private static final int DIMENSION_START_ID

      See Also:
        Constant Field Values

    - #### DIMENSION_INCREMENT_ID

          private static final int DIMENSION_INCREMENT_ID

      See Also:
        Constant Field Values

    - #### DIMENSION_VALUE_ID

          private static final int DIMENSION_VALUE_ID

      See Also:
        Constant Field Values

    - #### CHANNEL_NAME

          private static final int CHANNEL_NAME

      See Also:
        Constant Field Values

    - #### Z

          private static final int Z

      See Also:
        Constant Field Values

    - #### T

          private static final int T

      See Also:
        Constant Field Values

    - #### LAMBDA

          private static final int LAMBDA

      See Also:
        Constant Field Values

    - #### C

          private static final int C

      See Also:
        Constant Field Values

    - #### UNKNOWN

          private static final int UNKNOWN

      See Also:
        Constant Field Values

    - #### PHASE

          private static final int PHASE

      See Also:
        Constant Field Values

    - #### DISPLAY_LIMITS

          private static final int DISPLAY_LIMITS

      See Also:
        Constant Field Values

    - #### STACK_DISPLAY_LUT

          private static final int STACK_DISPLAY_LUT

      See Also:
        Constant Field Values

    - #### GAMMA_CORRECTION

          private static final int GAMMA_CORRECTION

      See Also:
        Constant Field Values

    - #### FRAME_ORIGIN

          private static final int FRAME_ORIGIN

      See Also:
        Constant Field Values

    - #### FRAME_SCALE

          private static final int FRAME_SCALE

      See Also:
        Constant Field Values

    - #### DISPLAY_COLOR

          private static final int DISPLAY_COLOR

      See Also:
        Constant Field Values

    - #### CREATION_TIME

          private static final int CREATION_TIME

      See Also:
        Constant Field Values

    - #### RWC_FRAME_ORIGIN

          private static final int RWC_FRAME_ORIGIN

      See Also:
        Constant Field Values

    - #### RWC_FRAME_SCALE

          private static final int RWC_FRAME_SCALE

      See Also:
        Constant Field Values

    - #### RWC_FRAME_UNIT

          private static final int RWC_FRAME_UNIT

      See Also:
        Constant Field Values

    - #### STACK_NAME

          private static final int STACK_NAME

      See Also:
        Constant Field Values

    - #### CHANNEL_DIM

          private static final int CHANNEL_DIM

      See Also:
        Constant Field Values

    - #### OPTICAL_PATH

          private static final int OPTICAL_PATH

      See Also:
        Constant Field Values

    - #### STACK_TYPE

          private static final int STACK_TYPE

      See Also:
        Constant Field Values

    - #### LIVE_OVERFLOW

          private static final int LIVE_OVERFLOW

      See Also:
        Constant Field Values

    - #### IS_TRANSMISSION

          private static final int IS_TRANSMISSION

      See Also:
        Constant Field Values

    - #### CONTRAST_BRIGHTNESS

          private static final int CONTRAST_BRIGHTNESS

      See Also:
        Constant Field Values

    - #### ACQUISITION_PROPERTIES

          private static final int ACQUISITION_PROPERTIES

      See Also:
        Constant Field Values

    - #### GRADIENT_LUT

          private static final int GRADIENT_LUT

      See Also:
        Constant Field Values

    - #### CALIBRATION

          private static final int CALIBRATION

      See Also:
        Constant Field Values

    - #### DEFAULT_IMAGE

          private static final int DEFAULT_IMAGE

      See Also:
        Constant Field Values

    - #### OVERVIEW_IMAGE

          private static final int OVERVIEW_IMAGE

      See Also:
        Constant Field Values

    - #### SAMPLE_MASK

          private static final int SAMPLE_MASK

      See Also:
        Constant Field Values

    - #### FOCUS_IMAGE

          private static final int FOCUS_IMAGE

      See Also:
        Constant Field Values

    - #### EFI_SHARPNESS_MAP

          private static final int EFI_SHARPNESS_MAP

      See Also:
        Constant Field Values

    - #### EFI_HEIGHT_MAP

          private static final int EFI_HEIGHT_MAP

      See Also:
        Constant Field Values

    - #### EFI_TEXTURE_MAP

          private static final int EFI_TEXTURE_MAP

      See Also:
        Constant Field Values

    - #### EFI_STACK

          private static final int EFI_STACK

      See Also:
        Constant Field Values

    - #### MACRO_IMAGE

          private static final int MACRO_IMAGE

      See Also:
        Constant Field Values

    - #### DISPLAY_PROCESSOR_TYPE

          private static final int DISPLAY_PROCESSOR_TYPE

      See Also:
        Constant Field Values

    - #### RENDER_OPERATION_ID

          private static final int RENDER_OPERATION_ID

      See Also:
        Constant Field Values

    - #### DISPLAY_STACK_ID

          private static final int DISPLAY_STACK_ID

      See Also:
        Constant Field Values

    - #### TRANSPARENCY_ID

          private static final int TRANSPARENCY_ID

      See Also:
        Constant Field Values

    - #### THIRD_ID

          private static final int THIRD_ID

      See Also:
        Constant Field Values

    - #### DISPLAY_VISIBLE

          private static final int DISPLAY_VISIBLE

      See Also:
        Constant Field Values

    - #### TRANSPARENCY_VALUE

          private static final int TRANSPARENCY_VALUE

      See Also:
        Constant Field Values

    - #### DISPLAY_LUT

          private static final int DISPLAY_LUT

      See Also:
        Constant Field Values

    - #### DISPLAY_STACK_INDEX

          private static final int DISPLAY_STACK_INDEX

      See Also:
        Constant Field Values

    - #### CHANNEL_TRANSPARENCY_VALUE

          private static final int CHANNEL_TRANSPARENCY_VALUE

      See Also:
        Constant Field Values

    - #### CHANNEL_VISIBLE

          private static final int CHANNEL_VISIBLE

      See Also:
        Constant Field Values

    - #### SELECTED_CHANNELS

          private static final int SELECTED_CHANNELS

      See Also:
        Constant Field Values

    - #### DISPLAY_GAMMA_CORRECTION

          private static final int DISPLAY_GAMMA_CORRECTION

      See Also:
        Constant Field Values

    - #### CHANNEL_GAMMA_CORRECTION

          private static final int CHANNEL_GAMMA_CORRECTION

      See Also:
        Constant Field Values

    - #### DISPLAY_CONTRAST_BRIGHTNESS

          private static final int DISPLAY_CONTRAST_BRIGHTNESS

      See Also:
        Constant Field Values

    - #### CHANNEL_CONTRAST_BRIGHTNESS

          private static final int CHANNEL_CONTRAST_BRIGHTNESS

      See Also:
        Constant Field Values

    - #### ACTIVE_STACK_DIMENSION

          private static final int ACTIVE_STACK_DIMENSION

      See Also:
        Constant Field Values

    - #### SELECTED_FRAMES

          private static final int SELECTED_FRAMES

      See Also:
        Constant Field Values

    - #### DISPLAYED_LUT_ID

          private static final int DISPLAYED_LUT_ID

      See Also:
        Constant Field Values

    - #### HIDDEN_LAYER

          private static final int HIDDEN_LAYER

      See Also:
        Constant Field Values

    - #### LAYER_XY_FIXED

          private static final int LAYER_XY_FIXED

      See Also:
        Constant Field Values

    - #### ACTIVE_LAYER_VECTOR

          private static final int ACTIVE_LAYER_VECTOR

      See Also:
        Constant Field Values

    - #### ACTIVE_LAYER_INDEX_VECTOR

          private static final int ACTIVE_LAYER_INDEX_VECTOR

      See Also:
        Constant Field Values

    - #### CHAINED_LAYERS

          private static final int CHAINED_LAYERS

      See Also:
        Constant Field Values

    - #### LAYER_SELECTION

          private static final int LAYER_SELECTION

      See Also:
        Constant Field Values

    - #### LAYER_SELECTION_INDEX

          private static final int LAYER_SELECTION_INDEX

      See Also:
        Constant Field Values

    - #### CANVAS_COLOR_1

          private static final int CANVAS_COLOR_1

      See Also:
        Constant Field Values

    - #### CANVAS_COLOR_2

          private static final int CANVAS_COLOR_2

      See Also:
        Constant Field Values

    - #### ORIGINAL_FRAME_RATE

          private static final int ORIGINAL_FRAME_RATE

      See Also:
        Constant Field Values

    - #### USE_ORIGINAL_FRAME_RATE

          private static final int USE_ORIGINAL_FRAME_RATE

      See Also:
        Constant Field Values

    - #### ACTIVE_CHANNEL

          private static final int ACTIVE_CHANNEL

      See Also:
        Constant Field Values

    - #### PLANE_UNIT

          private static final int PLANE_UNIT

      See Also:
        Constant Field Values

    - #### Y_PLANE_DIMENSION_UNIT

          private static final int Y_PLANE_DIMENSION_UNIT

      See Also:
        Constant Field Values

    - #### Y_DIMENSION_UNIT

          private static final int Y_DIMENSION_UNIT

      See Also:
        Constant Field Values

    - #### PLANE_ORIGIN_RWC

          private static final int PLANE_ORIGIN_RWC

      See Also:
        Constant Field Values

    - #### PLANE_SCALE_RWC

          private static final int PLANE_SCALE_RWC

      See Also:
        Constant Field Values

    - #### CHANNEL_OVERFLOW

          private static final int CHANNEL_OVERFLOW

      See Also:
        Constant Field Values

    - #### OBJECTIVE_MAG

          private static final int OBJECTIVE_MAG

      See Also:
        Constant Field Values

    - #### NUMERICAL_APERTURE

          private static final int NUMERICAL_APERTURE

      See Also:
        Constant Field Values

    - #### WORKING_DISTANCE

          private static final int WORKING_DISTANCE

      See Also:
        Constant Field Values

    - #### OBJECTIVE_NAME

          private static final int OBJECTIVE_NAME

      See Also:
        Constant Field Values

    - #### OBJECTIVE_TYPE

          private static final int OBJECTIVE_TYPE

      See Also:
        Constant Field Values

    - #### REFRACTIVE_INDEX

          private static final int REFRACTIVE_INDEX

      See Also:
        Constant Field Values

    - #### DEVICE_NAME

          private static final int DEVICE_NAME

      See Also:
        Constant Field Values

    - #### DEVICE_ID

          private static final int DEVICE_ID

      See Also:
        Constant Field Values

    - #### DEVICE_SUBTYPE

          private static final int DEVICE_SUBTYPE

      See Also:
        Constant Field Values

    - #### DEVICE_MANUFACTURER

          private static final int DEVICE_MANUFACTURER

      See Also:
        Constant Field Values

    - #### VALUE

          private static final int VALUE

      See Also:
        Constant Field Values

    - #### usedFiles

          private java.lang.String[] usedFiles

    - #### extraFiles

          private java.util.ArrayList<java.lang.String> extraFiles

    - #### fileMap

          private java.util.HashMap<java.lang.Integer,java.lang.String> fileMap

    - #### parser

          private TiffParser parser

    - #### ifds

          private IFDList ifds

    - #### tileOffsets

          private java.util.ArrayList<java.lang.Long[]> tileOffsets

    - #### jpeg

          private boolean jpeg

    - #### rows

          private java.util.ArrayList<java.lang.Integer> rows

    - #### cols

          private java.util.ArrayList<java.lang.Integer> cols

    - #### compressionType

          private java.util.ArrayList<java.lang.Integer> compressionType

    - #### tileX

          private java.util.ArrayList<java.lang.Integer> tileX

    - #### tileY

          private java.util.ArrayList<java.lang.Integer> tileY

    - #### tileMap

          private java.util.ArrayList<java.util.ArrayList<CellSensReader.TileCoordinate>> tileMap

    - #### nDimensions

          private java.util.ArrayList<java.lang.Integer> nDimensions

    - #### inDimensionProperties

          private boolean inDimensionProperties

    - #### foundChannelTag

          private boolean foundChannelTag

    - #### dimensionTag

          private int dimensionTag

    - #### backgroundColor

          private java.util.HashMap<java.lang.Integer,byte[]> backgroundColor

    - #### metadataIndex

          private int metadataIndex

    - #### previousTag

          private int previousTag

    - #### pyramids

          private java.util.ArrayList<CellSensReader.Pyramid> pyramids

    - #### bgr

          private boolean[] bgr

    - #### expectETS

          private transient boolean expectETS

    - #### channelCount

          private transient int channelCount

    - #### zCount

          private transient int zCount

  - ### Constructor Detail

    - #### CellSensReader

          public CellSensReader()

      Constructs a new cellSens reader.

  - ### Method Detail

    - #### failOnMissingETS

          public boolean failOnMissingETS()

    - #### fileGroupOption

          public int fileGroupOption(java.lang.String id)
                              throws FormatException,
                                     java.io.IOException

      Description copied from interface: `IFormatReader`
      Returns an indication of whether the files in a multi-file dataset can be handled individually. This method is only useful for formats and datasets which contain multiple files.
      Specified by:
        `fileGroupOption` in interface `IFormatReader`
      Overrides:
        `fileGroupOption` in class `FormatReader`
      Parameters:
        `id` - a file in the multi-file dataset
      Returns:
        an int indicating that we cannot, must, or might group the files. A return value of `FormatTools.MUST_GROUP` indicates that the files cannot be handled separately; the reader will always detect and read all files in the dataset. `FormatTools.CAN_GROUP` indicates that the files may be handled separately, but file grouping must then be disabled via `IFormatReader.setGroupFiles(boolean)`. `FormatTools.CANNOT_GROUP` indicates that the files must be handled separately; the reader will not attempt to read all files in the dataset (this is rare).
      Throws:
        `FormatException`
        `java.io.IOException`
      See Also:
        `FormatTools.MUST_GROUP`, `FormatTools.CAN_GROUP`, `FormatTools.CANNOT_GROUP`

    - #### isSingleFile

          public boolean isSingleFile(java.lang.String id)
                               throws FormatException,
                                      java.io.IOException

      Description copied from interface: `IFormatReader`
      Returns true if the named file is expected to be the only file in the dataset. For single-file formats, always returns true.
      Specified by:
        `isSingleFile` in interface `IFormatReader`
      Overrides:
        `isSingleFile` in class `FormatReader`
      Throws:
        `FormatException`
        `java.io.IOException`

    - #### getSeriesUsedFiles

          public java.lang.String[] getSeriesUsedFiles(boolean noPixels)

      Description copied from interface: `IFormatReader`
      Returns an array of filenames needed to open the current series. If the 'noPixels' flag is set, then only files that do not contain pixel data will be returned. The first element in the array is expected to be the path passed to `IFormatHandler.setId(String)`, if appropriate based upon 'noPixels'. The remaining elements are expected to be in a consistent order; if a directory listing is necessary to build the list then it should be sorted first.
      Specified by:
        `getSeriesUsedFiles` in interface `IFormatReader`
      Overrides:
        `getSeriesUsedFiles` in class `FormatReader`

    - #### getOptimalTileWidth

          public int getOptimalTileWidth()

      Description copied from interface: `IFormatReader`
      Returns the optimal sub-image width for use with openBytes.
      Specified by:
        `getOptimalTileWidth` in interface `IFormatReader`
      Overrides:
        `getOptimalTileWidth` in class `FormatReader`

    - #### getOptimalTileHeight

          public int getOptimalTileHeight()

      Description copied from interface: `IFormatReader`
      Returns the optimal sub-image height for use with openBytes.
      Specified by:
        `getOptimalTileHeight` in interface `IFormatReader`
      Overrides:
        `getOptimalTileHeight` in class `FormatReader`

    - #### openThumbBytes

          public byte[] openThumbBytes(int no)
                                throws FormatException,
                                       java.io.IOException

      Description copied from interface: `IFormatReader`
      Obtains a thumbnail for the specified image plane from the current file, as a byte array.
      Specified by:
        `openThumbBytes` in interface `IFormatReader`
      Overrides:
        `openThumbBytes` in class `FormatReader`
      Throws:
        `FormatException`
        `java.io.IOException`

    - #### openBytes

          public byte[] openBytes(int no,
                                  byte[] buf,
                                  int x,
                                  int y,
                                  int w,
                                  int h)
                           throws FormatException,
                                  java.io.IOException

      Description copied from interface: `IFormatReader`
      Obtains a sub-image of the specified image plane into a pre-allocated byte array.
      Specified by:
        `openBytes` in interface `IFormatReader`
      Specified by:
        `openBytes` in class `FormatReader`
      Parameters:
        `no` - the plane index within the current series.
        `buf` - a pre-allocated buffer.
        `x` - X coordinate of the upper-left corner of the sub-image
        `y` - Y coordinate of the upper-left corner of the sub-image
        `w` - width of the sub-image
        `h` - height of the sub-image
      Returns:
        the pre-allocated buffer `buf` for convenience.
      Throws:
        `FormatException` - if there was a problem parsing the metadata of the file.
        `java.io.IOException` - if there was a problem reading the file.
      See Also:
        `IFormatReader.openBytes(int, byte[], int, int, int, int)`

    - #### reopenFile

          public void reopenFile()
                          throws java.io.IOException

      Description copied from interface: `IFormatReader`
      Reopen any files that were closed, and which are expected to be open while the reader is open. This assumes that `IFormatHandler.setId(java.lang.String)` has been called, but close(false) has not been called.
      Specified by:
        `reopenFile` in interface `IFormatReader`
      Overrides:
        `reopenFile` in class `FormatReader`
      Throws:
        `java.io.IOException`

    - #### close

          public void close(boolean fileOnly)
                     throws java.io.IOException

      Description copied from interface: `IFormatReader`
      Closes the currently open file. If the flag is set, this is all that happens; if unset, it is equivalent to calling `Closeable.close()`.
      Specified by:
        `close` in interface `IFormatReader`
      Overrides:
        `close` in class `FormatReader`
      Throws:
        `java.io.IOException`

    - #### getAvailableOptions

          protected java.util.ArrayList<java.lang.String> getAvailableOptions()

      Description copied from class: `FormatReader`
      Returns the list of available metadata options.
      Overrides:
        `getAvailableOptions` in class `FormatReader`

    - #### initFile

          protected void initFile(java.lang.String id)
                           throws FormatException,
                                  java.io.IOException

      Description copied from class: `FormatReader`
      Initializes the given file (parsing header information, etc.). Most subclasses should override this method to perform initialization operations such as parsing metadata.
      Overrides:
        `initFile` in class `FormatReader`
      Throws:
        `FormatException` - if a parsing error occurs processing the file.
        `java.io.IOException` - if an I/O error occurs processing the file

    - #### getTileSize

          private int getTileSize()

      Get the expected decompressed size of a single tile, in bytes.

    - #### getCurrentPyramidIndex

          private int getCurrentPyramidIndex()

      Get an index to the pyramid which contains the current series/resolution. Accounts for flattened resolutions as needed.

    - #### getCurrentPyramid

          private CellSensReader.Pyramid getCurrentPyramid()

      Get an object representing the pyramid which contains the current series/resolution. Accounts for flattened resolutions as needed.

    - #### getResolutionIndex

          private int getResolutionIndex()

      Get the current pyramid resolution, accounting for flattened resolutions as needed.

    - #### decodeTile

          private byte[] decodeTile(int no,
                                    int row,
                                    int col)
                             throws FormatException,
                                    java.io.IOException

      Throws:
        `FormatException`
        `java.io.IOException`

    - #### parseETSFile

          private boolean parseETSFile(loci.common.RandomAccessInputStream etsFile,
                                       java.lang.String file,
                                       int s,
                                       boolean hasOrphanEtsFiles)
                                throws FormatException,
                                       java.io.IOException

      Throws:
        `FormatException`
        `java.io.IOException`

    - #### convertPixelType

          private int convertPixelType(int pixelType)
                                throws FormatException

      Throws:
        `FormatException`

    - #### readTags

          private void readTags(loci.common.RandomAccessInputStream vsi,
                                boolean populateMetadata,
                                java.lang.String tagPrefix)

    - #### getVolumeName

          private java.lang.String getVolumeName(int tag)

    - #### getTagName

          private java.lang.String getTagName(int tag)

    - #### getDeviceSubtype

          private java.lang.String getDeviceSubtype(java.lang.String type)

    - #### getStackType

          private java.lang.String getStackType(java.lang.String type)

    - #### getIFDIndex

          private int getIFDIndex()

Copyright © 2026 Open Microscopy Environment